#ifndef __ASM_ALPHA_PREFETCH_H
#define __ASM_ALPHA_PREFETCH_H

#define ARCH_HAS_PREFETCH
#define ARCH_HAS_PREFETCHW
#define ARCH_HAS_SPINLOCK_PREFETCH

extern inline void prefetch(const void *ptr)  
{ 
	__asm__ ("ldl $31,%0" : : "m"(*(char *)ptr)); 
}

extern inline void prefetchw(const void *ptr)  
{
	__asm__ ("ldl $31,%0" : : "m"(*(char *)ptr)); 
}

extern inline void spin_lock_prefetch(const void *ptr)  
{
	__asm__ ("ldl $31,%0" : : "m"(*(char *)ptr)); 
}

#endif /* __ASM_ALPHA_PREFETCH_H */
